#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <conio.h>

void gauss(double a[11][11],double s[11],int n)
{
	int i,j;
	for(i=1;i<=n;i++)
	{
		s[i] = fabs(a[i][1]);
		for(j=2;j<=n;j++)
		{
			if(fabs(a[i][j])>s[i])
			{
			s[i]=fabs(a[i][j]);
			}
		}
	}
}

void pivot(double a[11][11],double s[11],double b[11],double a_ivs[11][11],int k,int n) 
{
	int i,j,p;
	double big,dummy;

	p=k;
	big=fabs(a[k][k]/s[k]);
	for(i=k+1;i<=n;i++)
	{
		dummy=fabs(a[i][k]/s[i]);
		if(dummy>big)
		{
			big=dummy;
			p=i;
		}
	}

	if(p!=k)
	{
		for(j=1;j<=n;j++)
		{
			dummy=a[p][j];
			a[p][j]=a[k][j];
			a[k][j]=dummy;
			dummy=a_ivs[p][j];
			a_ivs[p][j]=a_ivs[k][j];
			a_ivs[k][j]=dummy;
		}
		dummy=b[p];
		b[p]=b[k];
		b[k]=dummy;
		dummy=s[p];
		s[p]=s[k];
		s[k]=dummy;
	}
}

int eliminate(double a[11][11],double s[11],double b[11],double a_ivs[11][11],int n,int er)
{
	int i,j,k=0;
	double factor;
	for(k=1;k<=n;k++)
	{
		pivot(a,s,b,a_ivs,k,n);
		if(fabs(a[k][k]/s[k]) < 0.000000000000001)
		{
			er=-1;
		}
		for(i=k+1;i<=n;i++)
		{
			factor=a[i][k]/a[k][k];
			for(j=1;j<=n;j++)
			{
				a[i][j]=a[i][j]-factor*a[k][j];
				a_ivs[i][j]=a_ivs[i][j]-factor*a_ivs[k][j];
			}
			b[i]=b[i]-factor*b[k];			
		}
	}
	
	for(k=n;k>=1;k--)
	{
		for(i=k-1;i>=1;i--)
		{
			factor=a[i][k]/a[k][k];
			for(j=n;j>=1;j--)
			{
				a[i][j]=a[i][j]-factor*a[k][j];
				a_ivs[i][j]=a_ivs[i][j]-factor*a_ivs[k][j];
			}
			b[i]=b[i]-factor*b[k];	
		}
	}

	for(i=1;i<=n;i++)
	{
		for(j=1;j<=n;j++)
		{
			a_ivs[i][j]=a_ivs[i][j]/a[i][i];
		}
		b[i]=b[i]/a[i][i];
	}

	return er;
}

void substitute(double a[11][11],double b[11],double x[11],int n)
{
	int i,j;
	double sum;
	x[n]=b[n]/a[n][n];
	for(i=n-1;i>=1;i--)
	{
		sum=0;
		for(j=i+1;j<=n;j++)
		{
			sum=sum+a[i][j]*x[j];
		}
		x[i]=(b[i]-sum)/a[i][i];
	}
}


void main()
{
	double a[11][11],a_ivs[11][11],veri[11][11];
	double b[11];
	double s[11];
	double x[11];
	double dummy;
	int i,j,k,n,er=1;
	FILE *input;

	choose:
	printf("Choose n by n matrix! : ");
	scanf("%d",&n);
	if(n<1||n>10)
	{
		printf("error!!\n");
		goto choose;
	}
// a_ivs array initializing
	for(i=1;i<=9;i++)
	{
		for(j=1;j<=9;j++)
		{
			if(i==j)
			{
				a_ivs[i][j]=1;
			}
			else
			a_ivs[i][j]=0;
		}
	}
	
	input=fopen("input.txt","r");
	for(i=1;i<=n;i++)
	{
		for(j=1;j<=n;j++)
		{
			while(NULL==fscanf(input,"%lf",&dummy))
			{
				fseek(input, 1, SEEK_CUR);
			}
			a[i][j]=dummy;
		}
		
		while(NULL==fscanf(input,"%lf",&dummy))
		{
				fseek(input, 1, SEEK_CUR);
		}
		b[i]=dummy;
	}
	fclose(input);

	gauss(a,s,n);
    er=eliminate(a,s,b,a_ivs,n,er);
	substitute(a,b,x,n);

	if(er==-1)
	{
		printf("error!!\n");
	}
	else
	for(i=1;i<=n;i++)
	{
		printf("x[%d] is %.18f\n",i,x[i]);
	}

	input=fopen("input.txt","r");
	for(i=1;i<=n;i++)
	{
		for(j=1;j<=n;j++)
		{
			while(NULL==fscanf(input,"%lf",&dummy))
			{
				fseek(input, 1, SEEK_CUR);
			}
			a[i][j]=dummy;
		}
		
		while(NULL==fscanf(input,"%lf",&dummy))
		{
				fseek(input, 1, SEEK_CUR);
		}
		b[i]=dummy;
	}
	fclose(input);
	
	printf("\n--------Matrix A--------\n");
	for(i=1;i<=n;i++)
	{
		for(j=1;j<=n;j++)
		{
		printf(" %f",a[i][j]);
		}
		printf("\n");
	}

	printf("\n--------Matrix INVERSE A--------\n");
	for(i=1;i<=n;i++)
	{
		for(j=1;j<=n;j++)
		{
		printf(" %f",a_ivs[i][j]);
		}
		printf("\n");
	}

	for(i=1;i<=n;i++)
	{
		for(j=1;j<=n;j++)
		{
			veri[i][j]=0;
			for(k=1;k<=n;k++)
			{
				veri[i][j]=veri[i][j]+a[i][k]*a_ivs[k][j];
			}
		}
	}

	printf("\n--------Verification--------\n");
	for(i=1;i<=n;i++)
	{
		for(j=1;j<=n;j++)
		{
		printf(" %.10f",veri[i][j]);
		}
		printf("\n");
	}  

	getch();
}